/**
 * Copyright (C) 2017 Wasabeef
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var RE = {};

RE.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

RE.editor = document.getElementById('editor');

//RE.editor = document.getElementById('editor').style.lineHeight="25px";//设置行间距

document.addEventListener("selectionchange", function() { RE.backuprange(); });

// Initializations
RE.callback = function() {
    window.location.href = "re-callback://" + encodeURI(RE.getHtml());
}

RE.setHtml = function(contents) {
    RE.editor.innerHTML = decodeURIComponent(contents.replace(/\+/g, '%20'));
}

RE.getHtml = function() {
    return RE.editor.innerHTML;
}

RE.getText = function() {
    return RE.editor.innerText;
}

RE.setBaseTextColor = function(color) {
    RE.editor.style.color  = color;
}

RE.setBaseFontSize = function(size) {
    RE.editor.style.fontSize = size;
}

RE.setPadding = function(left, top, right, bottom) {
  RE.editor.style.paddingLeft = left;
  RE.editor.style.paddingTop = top;
  RE.editor.style.paddingRight = right;
  RE.editor.style.paddingBottom = bottom;
}

RE.setBackgroundColor = function(color) {
    document.body.style.backgroundColor = color;
}

RE.setBackgroundImage = function(image) {
    RE.editor.style.backgroundImage = image;
}

RE.setWidth = function(size) {
    RE.editor.style.minWidth = size;
}

RE.setHeight = function(size) {
    RE.editor.style.height = size;
}

RE.setTextAlign = function(align) {
    RE.editor.style.textAlign = align;
}

RE.setVerticalAlign = function(align) {
    RE.editor.style.verticalAlign = align;
}

RE.setPlaceholder = function(placeholder) {
    RE.editor.setAttribute("placeholder", placeholder);
}

RE.setInputEnabled = function(inputEnabled) {
    RE.editor.contentEditable = String(inputEnabled);
}

RE.undo = function() {
    document.execCommand('undo', false, null);
}

RE.redo = function() {
    document.execCommand('redo', false, null);
}

RE.setBold = function() {
    document.execCommand('bold', false, null);
}

RE.setItalic = function() {
    document.execCommand('italic', false, null);
}

RE.setSubscript = function() {
    document.execCommand('subscript', false, null);
}

RE.setSuperscript = function() {
    document.execCommand('superscript', false, null);
}

RE.setStrikeThrough = function() {
    document.execCommand('strikeThrough', false, null);
}

RE.setUnderline = function() {
    document.execCommand('underline', false, null);
}

RE.setBullets = function() {
    document.execCommand('insertUnorderedList', false, null);
}

RE.setNumbers = function() {
    document.execCommand('insertOrderedList', false, null);
}

RE.setTextColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('foreColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setTextBackgroundColor = function(color) {
    RE.restorerange();
    document.execCommand("styleWithCSS", null, true);
    document.execCommand('hiliteColor', false, color);
    document.execCommand("styleWithCSS", null, false);
}

RE.setFontSize = function(fontSize){
    document.execCommand("fontSize", false, fontSize);
}

RE.setHeading = function(heading) {
    document.execCommand('formatBlock', false, '<h'+heading+'>');
}
RE.removeHeading = function(heading) {
    document.execCommand('formatBlock', false, '<p>');
}

RE.setIndent = function() {
    document.execCommand('indent', false, null);
}

RE.setOutdent = function() {
    document.execCommand('outdent', false, null);
}

RE.setJustifyLeft = function() {
    document.execCommand('justifyLeft', false, null);
}

RE.setJustifyCenter = function() {
    document.execCommand('justifyCenter', false, null);
}

RE.setJustifyRight = function() {
    document.execCommand('justifyRight', false, null);
}

RE.setBlockquote = function() {
    document.execCommand('formatBlock', false, '<blockquote>');
}

//<p align=center style="color:#aaaaaa">来亚米网的图片</p><hr align=center width=200 color=#aaaaaa size=1 /><br/>
RE.insertImage = function(url, alt) {
    var html = '<br/><div class="img-container"><img src="' + url + '" alt="' + alt + '" /></div><br/><br/>';
    RE.insertHTML(html);
}
//插入带id的<img>标签   保证同一条晒单里图片的唯一性
RE.insertImageContainId = function(url, alt,id,tags) {
//    var html = '<br/><div class="img-container"><img src="' + url + '" alt="' + alt + '" id="' + id + '"  /></div><br/><br/>';
        var html = '<br/><div class="img-container" id="div'+id+'">';
        html+=' <img  ';
        html+=' onload=\'javascript:setImageTag(this,'+tags+');\' ';
        html+=' width="100%" height="auto" class ="img" ';
        html+=' src="'+url+'" alt="'+alt+'" id="'+id+'" style="display:inline;" ';
        html+=' onclick=\'window.getImg.getImg("'+url+'","'+id+'");\' /> ';
        html+=' </div><br/><br/> ';
//      var html = '<br/><div class="img-container"><img src="' + url + '" alt="' + alt + '" id="' + id + '" onclick="window.getImg.getImg(11,22)" /></div><br/><br/>';
//var html = '<br/><div class="img-container"><img src="' + url + '" alt="' + alt + '" id="' + id + '" onclick="alert(1)" /></div><br/><br/>';
    RE.insertHTML(html);
}

RE.moveDiv = function(){
    alert("移动");
    var tagDivRight = document.getElementById("img-tagging right");
    alert(tagDivRight);
}

//插入图片完成
RE.insertImageContainIdEnd = function(){
    alert("插入图片完成");
}


RE.insertLocalImage = function(url, alt,width,height) {
    var html = '<br/><img src="' + url + '" alt="' + alt + '" width="' + width + '" height="' + height + '"/><br/><br/>';
    RE.insertHTML(html);
}

//插入分割线
RE.insertHr = function() {
    var html = '<p><hr color=#e2e2e2 size=1 /></p><br/>';
    RE.insertHTML(html);
}

//换行  插入分割线占位实现
RE.wrap = function(){
   var html = '<hr color=#ffffff style="background:transparent" size=1 /><br/>';
    RE.insertHTML(html);
}

RE.insertTag=function(tagList,IsEnglish){

        var html=document.getElementById('editor').innerHTML;
        var appendStr="";
        for ( var i = 0; i <tagList.length; i++){
            var item=tagList[i];
            if(delHtmlTag(html).indexOf((IsEnglish?item.topic_ename:item.topic_name))==-1){
                appendStr+="<a class='at-text-topic' data-topicid='"+item.topic_id+"' style='text-decoration: none;color:#4A90E2;' id='t_"+item.topic_id+"' href='"+item.jump_url+"'># "+(IsEnglish?item.topic_ename:item.topic_name)+" # </a>";
            }
        }
        document.execCommand('insertHTML', false, appendStr);
}
/**
@好友
*/
RE.insertAt=function(Friends){
var appendstr="";
for ( var i = 0; i <Friends.length; i++){
        var item=Friends[i];
        var html=document.getElementById('editor').innerHTML;
        if(delHtmlTag(html).indexOf("@"+item.user_name+"")==-1){
           appendstr+="<a class='at-text-user' data-userid='"+item.user_id+"' style='text-decoration: none;color:#4A90E2;' id='f_"+item.user_id+"' href='"+item.jump_url+"'>@"+item.user_name+" </a>";
        }
    }
    document.execCommand('insertHTML', false, appendstr);
}

 function delHtmlTag(str){
    var aStr=str.replace(/<[^>]+>/g,"");
    aStr=aStr.replace(/&nbsp;/ig, "");
    return aStr;//去掉所有的html标记
 }



RE.deleteTag=function(){
    document.execCommand('delete', false, null);
}

RE.insertHTML = function(html) {
    RE.restorerange();
    document.execCommand('insertHTML', false, html);
}

RE.insertLink = function(url, title) {
    RE.restorerange();
    var sel = document.getSelection();
    if (sel.toString().length == 0) {
        document.execCommand("insertHTML",false,"<p><a href='"+url+"'>"+title+"</a></p>");

    } else if (sel.rangeCount) {
       var el = document.createElement("a");
       el.setAttribute("href", url);
       el.setAttribute("title", title);

       var range = sel.getRangeAt(0).cloneRange();
       range.surroundContents(el);
       sel.removeAllRanges();
       sel.addRange(range);
   }
    RE.callback();
}

RE.setTodo = function(text) {
    var html = '<input type="checkbox" name="'+ text +'" value="'+ text +'"/> &nbsp;';
    document.execCommand('insertHTML', false, html);
}

RE.prepareInsert = function() {
    RE.backuprange();
}

RE.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
      var range = selection.getRangeAt(0);
      RE.currentSelection = {
          "startContainer": range.startContainer,
          "startOffset": range.startOffset,
          "endContainer": range.endContainer,
          "endOffset": range.endOffset};
    }
}

RE.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(RE.currentSelection.startContainer, RE.currentSelection.startOffset);
    range.setEnd(RE.currentSelection.endContainer, RE.currentSelection.endOffset);
    selection.addRange(range);
}

RE.enabledEditingItems = function(e) {
    var items = [];
    if (document.queryCommandState('bold')) {
        items.push('bold');
    }
    if (document.queryCommandState('italic')) {
        items.push('italic');
    }
    if (document.queryCommandState('subscript')) {
        items.push('subscript');
    }
    if (document.queryCommandState('superscript')) {
        items.push('superscript');
    }
    if (document.queryCommandState('strikeThrough')) {
        items.push('strikeThrough');
    }
    if (document.queryCommandState('underline')) {
        items.push('underline');
    }
    if (document.queryCommandState('insertOrderedList')) {
        items.push('orderedList');
    }
    if (document.queryCommandState('insertUnorderedList')) {
        items.push('unorderedList');
    }
    if (document.queryCommandState('justifyCenter')) {
        items.push('justifyCenter');
    }
    if (document.queryCommandState('justifyFull')) {
        items.push('justifyFull');
    }
    if (document.queryCommandState('justifyLeft')) {
        items.push('justifyLeft');
    }
    if (document.queryCommandState('justifyRight')) {
        items.push('justifyRight');
    }
    if (document.queryCommandState('insertHorizontalRule')) {
        items.push('horizontalRule');
    }
    var formatBlock = document.queryCommandValue('formatBlock');
    if (formatBlock.length > 0) {
        items.push(formatBlock);
    }

    window.location.href = "re-state://" + encodeURI(items.join(','));
}

RE.focus = function() {
    var range = document.createRange();
    range.selectNodeContents(RE.editor);
    range.collapse(false);
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(range);
    RE.editor.focus();
}

RE.blurFocus = function() {
    RE.editor.blur();
}

RE.removeFormat = function() {
    document.execCommand('removeFormat', false, null);
}
RE.deleteNowTag=function(tagContent){
   var BaseArray = document.getElementsByTagName('a'); //获取这个页面的所有A标签
    var hrefArr=[];
    for(var i=0;i<BaseArray.length;i++){
        hrefArr.push(BaseArray[i]);
    }
   var removeNode=null;
   var arrCount=hrefArr.length;
   for(var i=0;i<arrCount;i++){
        if(hrefArr[i]!=undefined){
            var itemContent=delHtmlTag(hrefArr[i].innerHTML);

            for(item of tagContent) {
                if(item.trim() === itemContent.trim()) {
                    //则包含该元素
                    removeNode=hrefArr[i];
                    removeNode.remove();
                }
            }
        }
   }
}


// Event Listeners
RE.editor.addEventListener("input", RE.callback);
RE.editor.addEventListener("keyup", function(e) {
    var KEY_LEFT = 37, KEY_RIGHT = 39;
    var KEY_DELETE=8;
    if (e.which == KEY_LEFT || e.which == KEY_RIGHT) {
        RE.enabledEditingItems(e);
    }else if(e.which==KEY_DELETE){
            // 删除逻辑
            // 1 ：由于在创建时默认会在 @xxx 后添加一个空格，
            // 所以当得知光标位于 @xxx 之后的一个第一个字符后并按下删除按钮时，
            // 应该将光标前的 @xxx 给删除
            // 2 ：当光标位于 @xxx 中间时，按下删除按钮时应该将整个 @xxx 给删除。
              var selection = getSelection();
              var range = selection.getRangeAt(0);
              var removeNode = null;
               //从中间删除
              if(range.startContainer.parentElement.className == "at-text-user"){
                removeNode = range.startContainer.parentElement;
                var user_id;
                var href = removeNode.getAttribute("href");
                if(href != null){
                   if(href.indexOf('center') != -1){
                       user_id = href.substring(href.lastIndexOf('/') + 1, href.length);
                       atUserDelete(decrypt(user_id));
                   }
                }else {
                  user_id = removeNode.getAttribute("data-userid");
                  atUserDelete(user_id);
                }
              }
                //从中间删除话题
              if(range.startContainer.parentElement.className == "at-text-topic"){
                removeNode = range.startContainer.parentElement;
                var topic_id;
                var href = removeNode.getAttribute("href");
                if(href != null){
                  if(href.indexOf('topics') != -1){
                    topic_id = href.substring(href.lastIndexOf('/') + 1, href.length);
                    atTopicDelete(topic_id)
                  }
                }else{
                  topic_id = removeNode.getAttribute("data-topicid");
                  atTopicDelete(topic_id)
                }
              }

               //删除IOS创建的话题/好友
              if(range.startContainer.parentElement.parentElement.nodeName == 'A'){
                removeNode = range.startContainer.parentElement.parentElement;
                var href = removeNode.getAttribute("href");
                if(href.indexOf('center') != -1){
                     var user_id = href.substring(href.lastIndexOf('/') + 1, href.length);
                     atUserDelete(decrypt(user_id))
                }else if(href.indexOf('topics') != -1){
                  var topic_id = href.substring(href.lastIndexOf('/') + 1, href.length);
                  atTopicDelete(topic_id)
                }
              }
            if (removeNode){
               removeNode.remove();
                e.preventDefault();
            }


    }
});
RE.editor.addEventListener("click", RE.enabledEditingItems);

function atUserDelete(user_id){
    window.deleteTag.atUserDelete(user_id);
}
function atTopicDelete(topic_id){
    window.deleteTag.atTopicDelete(topic_id);
}

/**
 * AES 字符串加密
 * @param text
 * @returns {*}
   */
function encrypt(text) {
  var key = CryptoJS.enc.Utf8.parse("bd12200aa530338c");
  var encryptedData = CryptoJS.AES.encrypt(text, key, {
    mode: CryptoJS.mode.ECB,
    padding: CryptoJS.pad.Pkcs7
  });
  return encode(encryptedData.toString());
};

/**
 * AES 字符串解密
 * @param text
 * @returns {*}
   */
 function decrypt(text) {
  var key = CryptoJS.enc.Utf8.parse("bd12200aa530338c");
  var decryptedData = CryptoJS.AES.decrypt(decode(text), key, {
    mode: CryptoJS.mode.ECB,
    padding: CryptoJS.pad.Pkcs7
  });
  return decryptedData.toString(CryptoJS.enc.Utf8);
}

var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

function encode(input){
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
            _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
            _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
}
function decode(input){
 var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
}

function _utf8_encode(string){
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }
        return utftext;
}
function _utf8_decode(utftext){
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while ( i < utftext.length ) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
}




function setImageTag(ele,tagGroupModelList) {
if (tagGroupModelList != null && tagGroupModelList.length > 0) {
        tagGroupModelList.forEach(function(val, index) {
			var top=ele.offsetHeight*val.percentY-12;
			var left=ele.offsetWidth*val.percentX;
			var right=ele.offsetWidth-ele.offsetWidth*val.percentX;
			var maxwidth=ele.offsetWidth/2*0.8;

			var tagnode = document.createElement("div");
			var ResultStr = "";
			tagnode.style.position="absolute";
            ele.parentNode.style.position="relative";

            if (val.percentX > 0.5) {
				tagnode.setAttribute("class","floating-tag body-on-left");
				tagnode.style.top=top+"px";
				tagnode.style.right=right+"px";
                ResultStr += "<div class=\"tagcircle\"></div>";
                ResultStr += "<a class=\"tagbubble\" style=\"text-decoration: none;\" target=\"_blank\" href=\"http://m.yamibuy.local/item/2107\">";
                ResultStr += "<div class=\"tagbubble-name\" style=\"max-width: "+maxwidth+"px;\">" + val.tags[0].name + "</div>";
                ResultStr += "</a>";
            } else {
		        tagnode.setAttribute("class","floating-tag body-on-right");
				tagnode.style.top=top+"px";
				tagnode.style.left=left+"px";
                ResultStr += "<div class=\"tagcircle\"></div>";
                ResultStr += "<a class=\"tagbubble\" style=\"text-decoration: none;\" target=\"_blank\" href=\"http://m.yamibuy.local/item/2107\">";
                ResultStr += "<div class=\"tagbubble-name\" style=\"max-width: "+maxwidth+"px;\">" + val.tags[0].name + "</div>";
                ResultStr += "</a>";
            }
			tagnode.innerHTML=ResultStr;
			ele.parentNode.appendChild(tagnode);
        });
    }
}


